<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.util.formatter.DateFormatter"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.Base"	
	import="net.sf.basedb.clients.web.util.HTML"	
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.meludi");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
	final Formatter dateFormat = new DateFormatter("yyyyMMdd");
%>
<base:page type="default" >
<base:head 
	scripts="~../meludi-2.js,~inspect_libprep_kit_data.js,~../sampleproc/extraction_utils.js" 
	styles="path.css,~../css/meludi-2.css"
	>
<style>
tr.highlight
{
	border-top-width: 1px;
	border-top-style: dotted;
}

#detailsTable
{
	width: 100%; 
	border-collapse: collapse;
	border-bottom-width: 1px;
	border-top-width: 1px;
}

#detailsTable td, #detailsTable th
{
	text-align: center;
	min-width: 5%;
	padding-top: 1px;
	padding-bottom: 1px;
}

#detailsTable .comment
{
	min-width: 10%;
}

#detailsTable .italic
{
	font-style: italic;
}

.nondefault
{
	background: #FFF066;
}
.nondefault:after
{
	content: '›';
}
.nondefault:before
{
	content: '‹';
}
span.status
{
	width: 20px;
	float: right;
}
</style>
</base:head>
<base:body>

	<p:path><p:pathelement 
		title="MeLuDi" href="<%="../index.jsp?ID="+ID%>" 
		/><p:pathelement title="Inspect/edit library preparation kit data" 
		/></p:path>

	<div class="content">

<!--
	<form name="meludi" action="extraction_protocol2.jsp" method="post" target="_blank" id="wizard" class="wizard">
-->
	<form name="meludi" id="wizard" class="wizard">
		<input type="hidden" name="ID" value="<%=ID%>">
		<input type="hidden" name="hiddenSubmitInfo" value="">
<!--
		<input type="hidden" name="hiddenNumItems" value="">
		<input type="hidden" name="hiddenCounterBalanceInfoRow" value="">
-->

	<div class="step auto-hide" id="step-1">
		<div class="step-no">1</div>
		<div class="step-title">Select what library preparation kit data to inspect</div>
		<div class="step-content">

			<table class="step-form">
			<tr>
				<td class="prompt">Library preparation kit filter</td>
				<td class="input">
					<select name="libPrepKitFilter" id="libPrepKitFilter"
						class="auto-init" data-auto-init="focus-on-enter" data-next-focus="">
						<option selected value="all" >All
						<option value="used_active">Used & active
						<option value="used_inactive">Used & inactive
						<option value="used">Used
						<option value="unused">Unused
						<option value="active">Active
						<option value="inactive">Inactive
					</select>
				</td>
				<td class="status" id="libPrepKitFilter.status"></td>
				<td class="help">
					<span id="libPrepKitFilter.message" class="message"></span>
					Library preparation kit filter.
				</td>
			</tr>
			</table>
		</div>
	</div>
	
	<!-- 2. Library preparation kit data information -->
	<div class="step" id="step-2">
		<div class="step-no">2</div>
		<div class="step-title">Library preparation kit data details</div>
		<div class="step-content">

			<div class="bg-filled-50" id="detailsLibPrepKitDataFileName" style="padding: 2px;"></div>
			<div class="bg-filled-50" id="libPrepKitFilterName" style="padding: 2px;"></div>

			<div id="detailsSection"></div>

			<table class="step-form">
			<tr>
				<td class="prompt">Download library preparation kit data file</td>
				<td class="input">
					<base:button id="downloadLibPrepKitDataFile" title="Download..."
						image="<%=home + "/images/download.png"%>" style="width:10em;" />
				</td>
				<td class="status" id="downloadLibPrepKitDataFile.status"></td>
				<td class="help">
					<span id="downloadLibPrepKitDataFile.message" class="message"></span>
					Download file with current kit data for future import/reference, with one row per kit.
				</td>
			</tr>
			</table>
		</div>
	</div>
	
	<div id="wizard-status"></div>
	
	<table class="navigation" id="navigation">
	<tr>
		<td><base:button id="gocancel" title="Cancel" /></td>
		<td><base:button id="gonext" title="Next" image="<%=home+"/images/gonext.png"%>" /></td>
		<td><base:button id="goregister" title="Register" image="<%=home+"/images/import.png"%>"  /></td>
		<td><base:button id="gorestart" title="Restart" image="<%=home+"/images/goback.png"%>" /></td>
<!--
		<td><base:button id="gocreate" title="Create library reagents report" image="<%=home+"/images/import.png"%>" /></td>
-->
		<td id="gonext-message" class="message"></td>
	</tr>
	</table>
	
	</form>

	</div>
	
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>