var InspectUsedKits = function()
{
	var inspectusedkits = {};
	
	var debug = 0;
	
	var kitNum = 0;
	var selectedKitName;
	var plateNameIsValid = false;
	var THIN_SPACE = '&#x2005;';

	// Page initialization
	inspectusedkits.initPage = function()
	{
		// Step 1
		Events.addEventHandler('step-1', 'wizard-initialize', inspectusedkits.initializeStep1);
		Events.addEventHandler('nofReservedFpaCells', 'change', inspectusedkits.numReservedCellsOnChange);
		inspectusedkits.initializeStep1();
	}

	inspectusedkits.initializeStep1 = function()
	{
		var frm = document.forms['meludi'];
		var numItems = frm.nofReservedFpaCells.value;

		Wizard.setCurrentStep(1);
		Doc.show('step-1');
		// Disable kit tables until they have been loaded
		Doc.hide('kitplatetablecontent');
		// Hide lib prep kit menu, that is only used internally
		Doc.hide('libPrepKit');

		// Check what library preparation kits are available
		var url = '../LibPrep.servlet?ID='+App.getSessionId();
		url += '&cmd=GetLibPrepKitsAsPlates';
		url += '&numItems=' + encodeURIComponent(numItems);
		
		Wizard.showLoadingAnimation('Loading information about kits...');
		Wizard.asyncJsonRequest(url, inspectusedkits.kitPlatesInfoLoaded);
	}

	inspectusedkits.kitPlatesInfoLoaded = function(response)
	{
		var frm = document.forms['meludi'];	
		var nofReservedFpaCells = frm.nofReservedFpaCells.value;
		var platesInfo = response.plates;
		if (platesInfo)
		{
			// Find header data
			//var numItems = names.length;
			var numItems = nofReservedFpaCells;
			var numUsedActiveKits = 0;
			var numUnusedActiveKits = 0;
			var usedActiveKitsJsonArr = [];
			var unusedActiveKitsJsonArr = [];
			var activeKitsJsonArr = [];
			for (var i = 0; i < platesInfo.length; i++)
			{
				var plateInfo = platesInfo[i];
				var bioplate = plateInfo;
				var expirationDate = bioplate.expirationDate;
				var numTimesUsed = bioplate.timesUsed;
				var unusedWellsJsonArr = bioplate.unusedWells;
				var effUnusedWellsJsonArr = bioplate.effUnusedWells;
				var reservedWellsJsonArr = bioplate.reservedWells;
				var numUnusedWells = unusedWellsJsonArr.length;
				var jsonKit = {};
				jsonKit['id'] = bioplate.kitId;
				jsonKit['name'] = bioplate.kitName;
				jsonKit['expirationDate'] = expirationDate;
				jsonKit['numTimesUsed'] = numTimesUsed;
				jsonKit['unusedWells'] = unusedWellsJsonArr;
				jsonKit['effUnusedWells'] = effUnusedWellsJsonArr;
				jsonKit['reservedWells'] = reservedWellsJsonArr;
				jsonKit['numUnusedWells'] = numUnusedWells;
				if (numUnusedWells < 48)
				{
					numUsedActiveKits++;
					usedActiveKitsJsonArr[usedActiveKitsJsonArr.length] = jsonKit;
				}
				else
				{
					numUnusedActiveKits++;
					unusedActiveKitsJsonArr[unusedActiveKitsJsonArr.length] = jsonKit;
				}
			}
			// List used kits first
			for (var i=0; i < usedActiveKitsJsonArr.length; i++)
			{
				activeKitsJsonArr[activeKitsJsonArr.length] = usedActiveKitsJsonArr[i];
			}
			// List unused kits after
			for (var i=0; i < unusedActiveKitsJsonArr.length; i++)
			{
				activeKitsJsonArr[activeKitsJsonArr.length] = unusedActiveKitsJsonArr[i];
			}

			// Form header
			var html = '';
			html += '<b>Number of DNA items: ' + numItems + '</b><br>';
/*
			html += '<b>Unused and active kits (' + numUnusedActiveKits + ')</b><br>';
			html += '<b>Used and active kits (' + numUsedActiveKits + '):</b><br>';
*/
			html += '<br>';
			html += 'Gray wells: Used<br>';
			html += 'Dark green wells: Unused but ignored due to placement rules<br>';
			html += 'Light green wells: Unused<br>';
			html += 'Yellow wells: Unused and reserved for selected FPA aliquots<br>';
			html += '<br>';

			// Display data for used and active kits
			var defaultKitSelected = false;
			var checkedStr = "";
			kitNum = 0;
			// Used and active kits
			html += '<td class="prompt"><b>Used and active kits (' + numUsedActiveKits + '):</b></td>';
			html += '<br>';
			html += '<br>';
			for (var i = 0; i < platesInfo.length; i++)
			{
				var plateInfo = platesInfo[i];
				var bioplate = plateInfo;
				var unusedWellsJsonArr = bioplate.unusedWells;
				var numUnusedWells = unusedWellsJsonArr.length;
				if (numUnusedWells < 48)
				{
					// Display half plate chart of unused wells for FPA aliquots
					var kitName = bioplate.kitName;
					var expirationDate = bioplate.expirationDate;
					var timesUsed = bioplate.timesUsed;
					var checkedStr = "";
					if (!defaultKitSelected)
					{
						selectedKitName = kitName;
						defaultKitSelected = true;
						checkedStr = " checked";
					}
/*
					html += '<td style="width: 3em;"><input type="radio" name="uselibprepkit.'+kitNum+'" id="uselibprepkit.'+kitNum+'" value="'+kitName+'"'+checkedStr+'><b>Kit: ' + kitName + '</b> [Exp. ' + Strings.encodeTags(expirationDate) + '] #Times used: ' + timesUsed + '</td><br>';
*/
					html += '<td style="width: 3em;"><b>' + (kitNum + 1) + '. Kit: ' + kitName + '</b> [Exp. ' + Strings.encodeTags(expirationDate) + '] #Times used: ' + timesUsed + '</td><br>';
					html += inspectusedkits.buildKitInfoPlate(bioplate);
					html += '<br>';
					kitNum++;
				}
			}
			// Unused kits
			html += '<td class="prompt"><b>Unused kits (' + unusedActiveKitsJsonArr.length + '):</b></td>';
			html += '<br>';
			for (var i=0; i < unusedActiveKitsJsonArr.length; i++)
			{
				var jsonKit = unusedActiveKitsJsonArr[i];
				var kitName = jsonKit['name'];
				var expirationDate = jsonKit['expirationDate'];
				var checkedStr = "";
				if (!defaultKitSelected)
				{
					selectedKitName = kitName;
					defaultKitSelected = true;
					checkedStr = " checked";
				}
				html += '<br>';
/*
				html += '<td style="width: 3em;"><input type="radio" name="uselibprepkit.'+kitNum+'" id="uselibprepkit.'+kitNum+'" value="'+kitName+'"'+checkedStr+'><b>Kit: ' + kitName + '</b> [Exp. ' + Strings.encodeTags(expirationDate) + ']</td>';
*/
				html += '<td style="width: 3em;"><b>' + (kitNum + 1) + '. Kit: ' + kitName + '</b> [Exp. ' + Strings.encodeTags(expirationDate) + ']</td>';
				kitNum++;
			}
			html += '<br>';
			if (activeKitsJsonArr.length == 0)
			{
				Wizard.setFatalError('No library preparation kits available.');
				return;
			}
			Doc.element('kitplatetablecontent').innerHTML = html;
			Doc.show('kitplatetablecontent');

/*
			for (var i=0; i < kitNum; i++)
			{
				// Add event handler for radio buttons
				Events.addEventHandler('uselibprepkit.'+i, 'change', inspectusedkits.kitOnChange, { 'index': i });
			}

			// Library preparation kit selection menu (hidden, but used internally)
			var libPrepKitList = frm.libPrepKit;
			if (activeKitsJsonArr.length > 0)
			{
				for (var i=0; i < activeKitsJsonArr.length; i++)
				{
					var jsonKit = activeKitsJsonArr[i];
					var kitName = jsonKit['name'];
					var expirationDate = jsonKit['expirationDate'];
					var numTimesUsed = jsonKit['numTimesUsed'];
					var numUnusedWells = jsonKit['numUnusedWells'];
					//
					var name = Strings.encodeTags(kitName);
					if (numUnusedWells != null && numTimesUsed != null)
					{
						name += ' -- (';
						name += '#Unused wells: ' + numUnusedWells;
						name += ' #Times used: ' + numTimesUsed;
						name += ')';
					}
					if (expirationDate)
					{
						name += ' [Exp. ' + Strings.encodeTags(expirationDate) + ']';
					}
					var selected = (i == 0);
					var option = new Option(name, kitName, selected, selected);
					option.jsonKit = jsonKit;
					libPrepKitList.options[libPrepKitList.length] = option;
				}
				libPrepKitList.options[0].selected = true;
			}
			else
			{
				Wizard.setFatalError('No library preparation kits available.');
				return;
			}
*/
		}
		Doc.removeClass('gonext', 'disabled');
	}

	inspectusedkits.kitOnChange = function(event)
	{
		var frm = document.forms['meludi'];
		var target = event.currentTarget;

		var index = Data.int(target, 'index');

		extraMaterialIsValid = true;

		selectedKitName = frm['uselibprepkit.'+index].value;

		// Reset all other radio buttons
		for (var i=0; i < kitNum; i++)
		{
			if (i != index)
			{
				Doc.element('uselibprepkit.'+i).checked = false;
			}
		}
	}

	inspectusedkits.numReservedCellsOnChange = function(event)
	{
		inspectusedkits.initializeStep1();
	}

	inspectusedkits.plateNameOnChange = function(event)
	{
		var frm = document.forms['meludi'];
		plateNameIsValid = false;
		
		var name = frm.plateName.value;
		if (!name || name == '')
		{
			Wizard.setInputStatus('plateName', 'invalid', 'Missing name');
			return;
		}
		if (name.indexOf("LP") != 0)
		{
			Wizard.setInputStatus('plateName', 'invalid', 'Plate name must start with prefix "LP"');
			return;
		}
		if (name.length != 7)
		{
			Wizard.setInputStatus('plateName', 'invalid', 'Plate name must consist of "LP" + 5 digits');
			return;
		}
		
		// Check if name exists
		var url = '../Extraction.servlet?ID='+App.getSessionId();
		url += '&cmd=CheckIfStartPlateNameUsed';
		url += '&startPlateName=' + encodeURIComponent(name);
		
		Wizard.showLoadingAnimation('Loading information about plate...');
		Wizard.asyncJsonRequest(url, inspectusedkits.plateInfoLoaded);
	}

	inspectusedkits.plateInfoLoaded = function(response)
	{
		var frm = document.forms['meludi'];	
		var plateInfo = response.startplate;
		if (plateInfo)
		{
			var plateName = plateInfo.name;
			var plateId = plateInfo.id;

			if (plateId)
			{
				plateNameIsValid = false;
				Wizard.setInputStatus('plateName', 'invalid', 'Plate already exists with name "' + plateName + '" (ID = ' + plateId + ')');
				return;
			}
		}
		plateNameIsValid = true;
		Plate.name = name;
		
		Wizard.setInputStatus('plateName', 'valid');
	}
	
	inspectusedkits.buildKitInfoPlate = function(plate)
	{
		var html = '';
		// Table row with kit data
		html += '<tr class="align-top">';
		// Added data for kit
		var kitName = plate.kitName;
		var expirationDate = plate.expirationDate;
		var timesUsed = plate.timesUsed;
		//
		var unusedWellsJsonArr = plate.unusedWells;
		var effUnusedWellsJsonArr = plate.effUnusedWells;
		var reservedWellsJsonArr = plate.reservedWells;

/*		
		html += '<td class="prompt"><b>Kit name: ' + kitName + '</b></td><br>';
		html += '<td class="prompt"><b>Expiration date: ' + expirationDate + '</b></td><br>';
		html += '<td class="prompt"><b>#Times used: ' + timesUsed + '</b></td><br>';
		html += '<td class="prompt"><b>#Available wells: ' + unusedWellsJsonArr.length + '</b></td><br>';
		html += '<td class="prompt"><b>#Eff. available wells: ' + effUnusedWellsJsonArr.length + '</b></td><br>';
*/
		// Kit as plate
		// Only show FPA columns, i.e. columns 0-5
		var colNoEnd = 5;
		if (plate.geometry.columns < colNoEnd)
		{
			colNoEnd = plate.geometry.columns;
		}
		html += '<td>';
		html += '<table class="plate">';
		html += '<tr class="header"><th></th>';
		for (var colNo = 0; colNo <= colNoEnd; colNo++)
		{
			html += '<th>'+(colNo+1)+'</th>';
		}
		html += '</tr>';
		var wells = plate.bioWells;
		var wellNo = 0;
		for (var rowNo = 0; rowNo < plate.geometry.rows; rowNo++)
		{
			html += '<tr class="row-'+rowNo+'">';
			html += '<th>'+Meludi.wellToAlpha(rowNo)+'</th>';
			for (var colNo = 0; colNo <= colNoEnd; colNo++)
			{
				var well = wells[wellNo];
				well.extraVolume = 0;
				well.comment = '';
				
				if (well.bioMaterial)
				{
					html += '<td id="well-'+well.id+'"';
					html += ' class="well selectable col-'+colNo+'"';
					html += ' title="'+Strings.encodeTags(well.bioMaterial.name)+'" data-well-id="'+well.id+'"';
					html += '>0'+THIN_SPACE+'µl</td>';
				}
				else
				{
					var wellName = Meludi.wellToAlpha(rowNo) + (colNo+1);
					// Check if kit is used for current well
					var usedWell = true;
					for (var i = 0; i < unusedWellsJsonArr.length; i++)
					{
						var nameOfUnusedWell = unusedWellsJsonArr[i];
						if (wellName == nameOfUnusedWell)
						{
							usedWell = false;
						}
					}
					var effUsedWell = true;
					for (var i = 0; i < effUnusedWellsJsonArr.length; i++)
					{
						var nameOfUnusedWell = effUnusedWellsJsonArr[i];
						if (wellName == nameOfUnusedWell)
						{
							effUsedWell = false;
						}
					}
					var reservedWell = false;
					for (var i = 0; i < reservedWellsJsonArr.length; i++)
					{
						var nameOfReservedWell = reservedWellsJsonArr[i];
						if (wellName == nameOfReservedWell)
						{
							reservedWell = true;
						}
					}
					if (usedWell)
					{
						// Empty well
						html += '<td class="kitwell empty col-'+colNo+'">';
					}
					else
					{
						// Unused well
						//html += '<td class="kitwell unused col-'+colNo+'">';
						var new_html = '';
						if (effUsedWell)
						{
							new_html = '<td class="kitwell unused col-'+colNo+'">';
						}
						else
						{
							new_html = '<td class="kitwell effunused col-'+colNo+'">';
							if (reservedWell)
							{
								new_html = '<td class="kitwell reserved col-'+colNo+'">';
							}
						}
						html += new_html;
					}
					html += '<div class="name">' + wellName + '</div>';
					html += '</td>';
				}
				wellNo++;
			}
			html += '</tr>';
		}
		html += '</table>';
		html += '</td>';
		// Kit status
		html += '<td class="status" id="libPrepKitAsPlate.status"></td>';
		// Kit message
		//var kitMessage = 'Highlighted wells are unused.';
		var kitMessage = '';
		html += '<td class="help">';
		html += '<span id="libPrepKitAsPlate.message" class="message" ></span>';
		html += kitMessage;
		html += '</td>';
		// End of table row with kit data
		html += '</tr>';

		return html;
	}

	return inspectusedkits;
}();

Doc.onLoad(InspectUsedKits.initPage);
Doc.addElementInitializer(InspectUsedKits.initElements);
