<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.WellCoordinateFormatter"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="m" uri="/WEB-INF/menu.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.meludi");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
%>
<base:page type="default">
<base:head 
	scripts="~../meludi-2.js,~inspect_libprep_used_kits.js,~plate.js,~pools.js,js-draw.js" 
	styles="path.css,toolbar.css,~../css/meludi-2.css,~../css/startplate.css"
	>
<style>

.kitwell
{
	height: 30px;
	max-height: 30px;
	min-height: 30px;
	width: 35px;
	max-width: 35px;
	min-width: 35px;
	font-weight: bold;
	font-size: 75%;
	vertical-align: middle;
	text-align: center;
	color: #C0C0C0;	
}

.kitwell.empty
{
	background-color: #E0E0E0;
	pointer-events: none;
}

.kitwell.unused
{
	background-color: #A0C0A0;
	pointer-events: none;
}

.kitwell.effunused
{
	background-color: #A0E0A0;
	pointer-events: none;
}

.kitwell.reserved
{
	background-color: #E0E0A0;
	pointer-events: none;
}

</style>
</base:head>
<base:body>
	<p:path><p:pathelement 
		title="MeLuDI" href="<%="../index.jsp?ID="+ID%>" 
		/><p:pathelement title="Inspect used library preparation kits" 
		/></p:path>

	<div id="canvas" class="absolutefull" style="z-index: -1;">
	
	<div class="content">

	<form name="meludi" id="wizard" class="wizard">
	
	<div class="step auto-hide" id="step-1">
		<div class="step-no">1</div>
		<div class="step-title">Select number of FPA extracts to reserve wells for</div>
		<div class="step-content">

			<table class="step-form">
			<tr class="align-top">
				<td class="prompt">Number of reserved wells</td>
				<td class="input">
					<select name="nofReservedFpaCells" id="nofReservedFpaCells"
						class="auto-init" data-auto-init="focus-on-enter" style="width:8em">
						<option selected value="0">0
						<option value="1">1
						<option value="2">2
						<option value="3">3
						<option value="4">4
						<option value="5">5
						<option value="6">6
						<option value="7">7
						<option value="8">8
						<option value="9">9
						<option value="10">10
						<option value="11">11
						<option value="12">12
						<option value="13">13
						<option value="14">14
						<option value="15">15
						<option value="16">16
						<option value="17">17
						<option value="18">18
						<option value="19">19
						<option value="20">20
						<option value="21">21
						<option value="22">22
						<option value="23">23
						<option value="24">24
						<option value="25">25
						<option value="26">26
						<option value="27">27
						<option value="28">28
						<option value="29">29
						<option value="30">30
						<option value="31">31
						<option value="32">32
						<option value="33">33
						<option value="34">34
						<option value="35">35
						<option value="36">36
						<option value="37">37
						<option value="38">38
						<option value="39">39
						<option value="40">40
						<option value="41">41
						<option value="42">42
						<option value="43">43
						<option value="44">44
						<option value="45">45
						<option value="46">46
						<option value="47">47
						<option value="48">48
					</select>
				</td>
				<td class="status" id="nofReservedFpaCells.status"></td>
				<td class="help">
					<span id="nofReservedFpaCells.message" class="message"></span>
					Number of FPA extracts to reserve wells for.
				</td>
			</tr>
			</table>

			<table class="step-form">
			<div name="kitplatetablecontent" id="kitplatetablecontent"></div>
			<tr class="align-top">
				<td class="input">
					<select name="libPrepKit" id="libPrepKit"></select>
				</td>
			</tr>
			</table>
		</div>
	</div>

	<div id="wizard-status"></div>

<!--	
	<table class="navigation" id="navigation">
	<tr>
		<td><base:button id="gocancel" title="Cancel" /></td>
		<td><base:button id="gonext" title="Next" image="<%=home+"/images/gonext.png"%>" /></td>
		<td><base:button id="goregister" title="Register" image="<%=home+"/images/import.png"%>"  /></td>
		<td><base:button id="gorestart" title="Restart" image="<%=home+"/images/goback.png"%>" /></td>
		<td><base:button id="gocreate" title="Create library preparation dilution protocol" image="<%=home+"/images/import.png"%>" /></td>
		<td id="gonext-message" class="message"></td>
	</tr>
	</table>
-->
	</form>
	</div>
	</div>
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>